#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 29 09:18:23 2019

@author: stan
"""

from antlr4 import CommonTokenStream,InputStream,ParseTreeWalker
from boolparse.BooleanSentenceLexer import BooleanSentenceLexer
from boolparse.BooleanSentenceParser import BooleanSentenceParser
from boolparse.sentece_listener import SentenceListener

class FormulaParser:
    
    @staticmethod
    def parse(formula):
        input_stream = InputStream(formula)
        lexer = BooleanSentenceLexer(input_stream)
        stream = CommonTokenStream(lexer)
        parser = BooleanSentenceParser(stream)
        tree = parser.init()
        listener = SentenceListener()
        walker = ParseTreeWalker()
        walker.walk(listener, tree)
        return (listener.get_expression(),listener.get_var_names())
